//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#ifdef DOOM2

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	A_CPosAttack
//
//  Heavy weapon dude attack.
//
//==========================================================================

void A_CPosAttack(mobj_t *actor)
{
	int			damage;
	TAVec		angles;
	TVec		vforward;
	
    if (!actor->target)
		return;

    StartSoundName(actor, "ShotgunFire");
    A_FaceTarget(actor);
	avcpy(actor->angles, angles);
    AimLineAttack(actor, &angles, MISSILERANGE);
    angles.yaw += (P_Random() - P_Random()) << 20;
	AngleVector(&angles, &vforward);
    damage = ((P_Random() % 5) + 1) * 3;
	LineAttack(actor, &vforward, MISSILERANGE, damage);
}

//==========================================================================
//
//	A_CPosRefire
//
//	Heavy weapon dude refire.
//
//==========================================================================

void A_CPosRefire(mobj_t *actor)
{	
    // keep firing unless target got out of sight
    A_FaceTarget(actor);

    if (P_Random() < 40)
		return;

    if (!actor->target || actor->target->health <= 0 ||
    	!P_CheckSight(actor, actor->target))
    {
		SetMobjState(actor, actor->seestate);
    }
}

#else

void A_CPosAttack(mobj_t *actor) { NotDoom2(); }
void A_CPosRefire(mobj_t *actor) { NotDoom2(); }

#endif
