//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**
//**************************************************************************
//**
//**	Weaponn info table
//**
//**	Generated by makeinfo.
//**
//**************************************************************************

void set_weapon_fist(player_t *player);
void set_weapon_crossbow(player_t *player);
void set_weapon_riffle(player_t *player);
void set_weapon_missile(player_t *player);
void set_weapon_grenade(player_t *player);
void set_weapon_flame(player_t *player);
void set_weapon_blaster(player_t *player);
void set_weapon_sigil(player_t *player);

weapon_func_t	weaponinfo[] =
{
	set_weapon_fist,
	set_weapon_crossbow,
	set_weapon_riffle,
	set_weapon_missile,
	set_weapon_grenade,
	set_weapon_flame,
	set_weapon_blaster,
	set_weapon_sigil,
};

int weapon_ammo_type[] =
{
	am_noammo,
	am_electric_arrow,
	am_clip,
	am_misl,
	am_grenade1,
	am_cell,
	am_cell,
	am_noammo,
};

//==========================================================================
//
//	set_weapon_fist
//
//==========================================================================

void set_weapon_fist(player_t *player)
{
	player->w_ammo = am_noammo;
	player->w_upstate = S_PUNCHUP;
	player->w_downstate = S_PUNCHDOWN;
	player->w_readystate = S_PUNCH;
	player->w_atkstate = S_PUNCH1;
	player->w_holdatkstate = S_NULL;
	player->w_flashstate = S_LIGHTDONE;
}

//==========================================================================
//
//	set_weapon_crossbow
//
//==========================================================================

void set_weapon_crossbow(player_t *player)
{
	player->w_ammo = am_electric_arrow;
	player->w_upstate = S_XBOWUP;
	player->w_downstate = S_XBOWDOWN;
	player->w_readystate = S_XBOW;
	player->w_atkstate = S_XBOW1;
	player->w_holdatkstate = S_NULL;
	player->w_flashstate = S_LIGHTDONE;
}

//==========================================================================
//
//	set_weapon_riffle
//
//==========================================================================

void set_weapon_riffle(player_t *player)
{
	player->w_ammo = am_clip;
	player->w_upstate = S_RIFFLEUP;
	player->w_downstate = S_RIFFLEDOWN;
	player->w_readystate = S_RIFFLE;
	player->w_atkstate = S_RIFFLE1;
	player->w_holdatkstate = S_NULL;
	player->w_flashstate = S_LIGHTDONE;
}

//==========================================================================
//
//	set_weapon_missile
//
//==========================================================================

void set_weapon_missile(player_t *player)
{
	player->w_ammo = am_misl;
	player->w_upstate = S_MISSILEUP;
	player->w_downstate = S_MISSILEDOWN;
	player->w_readystate = S_MISSILE;
	player->w_atkstate = S_MISSILE1;
	player->w_holdatkstate = S_NULL;
	player->w_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_grenade
//
//==========================================================================

void set_weapon_grenade(player_t *player)
{
	player->w_ammo = am_grenade1;
	player->w_upstate = S_GRENADEUP;
	player->w_downstate = S_GRENADEDOWN;
	player->w_readystate = S_GRENADE;
	player->w_atkstate = S_GRENADE1;
	player->w_holdatkstate = S_GRENADEFLASH1;
	player->w_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_flame
//
//==========================================================================

void set_weapon_flame(player_t *player)
{
	player->w_ammo = am_cell;
	player->w_upstate = S_FLAMEUP;
	player->w_downstate = S_FLAMEDOWN;
	player->w_readystate = S_FLAME;
	player->w_atkstate = S_FLAME1;
	player->w_holdatkstate = S_NULL;
	player->w_flashstate = S_LIGHTDONE;
}

//==========================================================================
//
//	set_weapon_blaster
//
//==========================================================================

void set_weapon_blaster(player_t *player)
{
	player->w_ammo = am_cell;
	player->w_upstate = S_BLASTERUP;
	player->w_downstate = S_BLASTERDOWN;
	player->w_readystate = S_BLASTER;
	player->w_atkstate = S_BLASTER1;
	player->w_holdatkstate = S_NULL;
	player->w_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_sigil
//
//==========================================================================

void set_weapon_sigil(player_t *player)
{
	player->w_ammo = am_noammo;
	player->w_upstate = S_SIGILUP;
	player->w_downstate = S_SIGILDOWN;
	player->w_readystate = S_SIGIL;
	player->w_atkstate = S_SIGIL1;
	player->w_holdatkstate = S_SIGILFLASH1;
	player->w_flashstate = S_NULL;
}

