//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**
//**************************************************************************
//**
//**	Mobj info table
//**
//**	Generated by makeinfo.
//**
//**************************************************************************

void generic_mobj_start(mobj_t *self, mthing_t *mthing);

//==========================================================================
//
//	misc_0
//
//==========================================================================

void misc_0(mobj_t *self, mthing_t *mthing)
{
	self->health = 10;
	self->spawnhealth = self->health;
	self->radius = 2.0;
	self->height = 1.0;
	self->mass = 10000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SHOOTABLE|MF_NOSECTOR;
	self->spawnstate = S_1295;
	self->deathstate = S_239;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_player
//
//==========================================================================

void misc_player(mobj_t *self, mthing_t *mthing)
{
	self->health = 100;
	self->spawnhealth = self->health;
	self->gibshealth = -50;
	self->radius = 18.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->painchance = 255;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_DROPOFF|MF_TRANSLATION1;
	self->spawnstate = S_PLAY;
	self->seestate = S_PLAY_RUN1;
	self->missilestate = S_PLAY_ATK1;
	self->painstate = S_PLAY_PAIN;
	self->deathstate = S_PLAY_DIE1;
	self->xdeathstate = S_PLAY_XDIE1;
	self->sound_pain = GetSoundID("Sound10");
	self->sound_death = GetSoundID("Sound17");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	npc_merchander1
//
//==========================================================================

void npc_merchander1(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Weapon_Smith";
	self->health = 10000000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 5000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE;
	self->spawnstate = S_MERCHANDER_STAND1;
	self->seestate = S_MERCHANDER_PAIN1;
	self->painstate = S_MERCHANDER_PAIN1;
	self->sound_pain = GetSoundID("Sound12");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	npc_merchander2
//
//==========================================================================

void npc_merchander2(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Bar_Keep";
	self->translation = 5;
	self->health = 10000000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 5000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE;
	self->spawnstate = S_MERCHANDER_STAND1;
	self->seestate = S_MERCHANDER_PAIN1;
	self->painstate = S_MERCHANDER_PAIN1;
	self->sound_active = GetSoundID("Sound52");
	self->sound_pain = GetSoundID("Sound53");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	npc_merchander3
//
//==========================================================================

void npc_merchander3(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Amorer";
	self->translation = 6;
	self->health = 10000000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 5000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE;
	self->spawnstate = S_MERCHANDER_STAND1;
	self->seestate = S_MERCHANDER_PAIN1;
	self->painstate = S_MERCHANDER_PAIN1;
	self->sound_pain = GetSoundID("Sound12");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	npc_merchander4
//
//==========================================================================

void npc_merchander4(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Medic";
	self->translation = 7;
	self->health = 10000000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 50000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE;
	self->spawnstate = S_MERCHANDER_STAND1;
	self->seestate = S_MERCHANDER_PAIN1;
	self->painstate = S_MERCHANDER_PAIN1;
	self->sound_pain = GetSoundID("Sound12");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_6
//
//==========================================================================

void misc_6(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 140.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_7
//
//==========================================================================

void misc_7(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 175.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_8
//
//==========================================================================

void misc_8(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 175.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_9
//
//==========================================================================

void misc_9(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 1;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_10
//
//==========================================================================

void misc_10(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 1;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_11
//
//==========================================================================

void misc_11(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 1;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_12
//
//==========================================================================

void misc_12(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 3;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_13
//
//==========================================================================

void misc_13(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 3;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_14
//
//==========================================================================

void misc_14(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 3;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_15
//
//==========================================================================

void misc_15(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 2;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_16
//
//==========================================================================

void misc_16(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 2;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_17
//
//==========================================================================

void misc_17(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 2;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_18
//
//==========================================================================

void misc_18(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 4;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_19
//
//==========================================================================

void misc_19(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 4;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_20
//
//==========================================================================

void misc_20(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 4;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_21
//
//==========================================================================

void misc_21(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 6;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_22
//
//==========================================================================

void misc_22(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 6;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_23
//
//==========================================================================

void misc_23(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 6;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_24
//
//==========================================================================

void misc_24(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 5;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_25
//
//==========================================================================

void misc_25(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 5;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_26
//
//==========================================================================

void misc_26(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 5;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_27
//
//==========================================================================

void misc_27(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 7;
	self->health = 31;
	self->spawnhealth = self->health;
	self->gibshealth = -15;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_385;
	self->seestate = S_386;
	self->meleestate = S_394;
	self->painstate = S_397;
	self->crashstate = S_399;
	self->deathstate = S_402;
	self->xdeathstate = S_410;
	self->sound_sight = GetSoundID("Sound47");
	self->sound_active = GetSoundID("Sound47");
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_28
//
//==========================================================================

void misc_28(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translation = 1;
	self->health = 31;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_420;
	self->painstate = S_421;
	self->deathstate = S_410;
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_29
//
//==========================================================================

void misc_29(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 61;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 255;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_422;
	self->painstate = S_423;
	self->deathstate = S_633;
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_30
//
//==========================================================================

void misc_30(mobj_t *self, mthing_t *mthing)
{
	self->health = 20;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SHOOTABLE|MF_NOSECTOR;
	self->spawnstate = S_424;
	self->sound_active = GetSoundID("Sound54");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_31
//
//==========================================================================

void misc_31(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 192.0;
	self->mass = 50000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_426;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_32
//
//==========================================================================

void misc_32(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 192.0;
	self->mass = 50000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_429;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_33
//
//==========================================================================

void misc_33(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 192.0;
	self->mass = 50000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_432;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_34
//
//==========================================================================

void misc_34(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 56.0;
	self->mass = 50000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_435;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_35
//
//==========================================================================

void misc_35(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 56.0;
	self->mass = 50000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_438;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_36
//
//==========================================================================

void misc_36(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 56.0;
	self->mass = 50000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_441;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_37
//
//==========================================================================

void misc_37(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 51;
	self->spawnhealth = self->health;
	self->radius = 6.0;
	self->height = 6.0;
	self->mass = 50000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 255;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_444;
	self->seestate = S_444;
	self->painstate = S_446;
	self->crashstate = S_449;
	self->deathstate = S_451;
	self->sound_active = GetSoundID("Sound99");
	self->sound_pain = GetSoundID("Sound100");
	self->sound_death = GetSoundID("Sound100");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_38
//
//==========================================================================

void misc_38(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Beggar";
	self->health = 20;
	self->spawnhealth = self->health;
	self->gibshealth = -10;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 105.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 250;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_458;
	self->seestate = S_459;
	self->meleestate = S_465;
	self->painstate = S_469;
	self->deathstate = S_471;
	self->xdeathstate = S_480;
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_39
//
//==========================================================================

void misc_39(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Beggar";
	self->health = 20;
	self->spawnhealth = self->health;
	self->gibshealth = -10;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 105.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 250;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_458;
	self->seestate = S_459;
	self->meleestate = S_465;
	self->painstate = S_469;
	self->deathstate = S_471;
	self->xdeathstate = S_480;
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_40
//
//==========================================================================

void misc_40(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Beggar";
	self->health = 20;
	self->spawnhealth = self->health;
	self->gibshealth = -10;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 105.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 250;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_458;
	self->seestate = S_459;
	self->meleestate = S_465;
	self->painstate = S_469;
	self->deathstate = S_471;
	self->xdeathstate = S_480;
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_41
//
//==========================================================================

void misc_41(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Beggar";
	self->health = 20;
	self->spawnhealth = self->health;
	self->gibshealth = -10;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 105.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 250;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_458;
	self->seestate = S_459;
	self->meleestate = S_465;
	self->painstate = S_469;
	self->deathstate = S_471;
	self->xdeathstate = S_480;
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_42
//
//==========================================================================

void misc_42(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Beggar";
	self->health = 20;
	self->spawnhealth = self->health;
	self->gibshealth = -10;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 105.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 250;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_JUSTHIT|MF_COUNTKILL;
	self->spawnstate = S_458;
	self->seestate = S_459;
	self->meleestate = S_465;
	self->painstate = S_469;
	self->deathstate = S_471;
	self->xdeathstate = S_480;
	self->sound_attack = GetSoundID("Sound2");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound61");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_43
//
//==========================================================================

void misc_43(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Rebel";
	self->health = 60;
	self->spawnhealth = self->health;
	self->gibshealth = -30;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 170;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL|MF_TRANSLATION1;
	self->spawnstate = S_481;
	self->seestate = S_492;
	self->missilestate = S_500;
	self->painstate = S_503;
	self->deathstate = S_505;
	self->xdeathstate = S_513;
	self->sound_sight = GetSoundID("Sound4");
	self->sound_active = GetSoundID("Sound47");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound20");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_44
//
//==========================================================================

void misc_44(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Rebel";
	self->health = 60;
	self->spawnhealth = self->health;
	self->gibshealth = -30;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 170;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL|MF_TRANSLATION1;
	self->spawnstate = S_481;
	self->seestate = S_492;
	self->missilestate = S_500;
	self->painstate = S_503;
	self->deathstate = S_505;
	self->xdeathstate = S_513;
	self->sound_sight = GetSoundID("Sound4");
	self->sound_active = GetSoundID("Sound47");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound20");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_45
//
//==========================================================================

void misc_45(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Rebel";
	self->health = 60;
	self->spawnhealth = self->health;
	self->gibshealth = -30;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 170;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL|MF_TRANSLATION1;
	self->spawnstate = S_481;
	self->seestate = S_492;
	self->missilestate = S_500;
	self->painstate = S_503;
	self->deathstate = S_505;
	self->xdeathstate = S_513;
	self->sound_sight = GetSoundID("Sound4");
	self->sound_active = GetSoundID("Sound47");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound20");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_46
//
//==========================================================================

void misc_46(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Rebel";
	self->health = 60;
	self->spawnhealth = self->health;
	self->gibshealth = -30;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 170;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL|MF_TRANSLATION1;
	self->spawnstate = S_481;
	self->seestate = S_492;
	self->missilestate = S_500;
	self->painstate = S_503;
	self->deathstate = S_505;
	self->xdeathstate = S_513;
	self->sound_sight = GetSoundID("Sound4");
	self->sound_active = GetSoundID("Sound47");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound20");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_47
//
//==========================================================================

void misc_47(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Rebel";
	self->health = 60;
	self->spawnhealth = self->health;
	self->gibshealth = -30;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 170;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL|MF_TRANSLATION1;
	self->spawnstate = S_481;
	self->seestate = S_492;
	self->missilestate = S_500;
	self->painstate = S_503;
	self->deathstate = S_505;
	self->xdeathstate = S_513;
	self->sound_sight = GetSoundID("Sound4");
	self->sound_active = GetSoundID("Sound47");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound20");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_48
//
//==========================================================================

void misc_48(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Rebel";
	self->health = 60;
	self->spawnhealth = self->health;
	self->gibshealth = -30;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 170;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL|MF_TRANSLATION1;
	self->spawnstate = S_481;
	self->seestate = S_492;
	self->missilestate = S_500;
	self->painstate = S_503;
	self->deathstate = S_505;
	self->xdeathstate = S_513;
	self->sound_sight = GetSoundID("Sound4");
	self->sound_active = GetSoundID("Sound47");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound20");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_49
//
//==========================================================================

void misc_49(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "MACIL";
	self->health = 95;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 250;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_521;
	self->seestate = S_528;
	self->missilestate = S_536;
	self->painstate = S_539;
	self->deathstate = S_528;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound47");
	self->sound_pain = GetSoundID("Sound12");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_50
//
//==========================================================================

void misc_50(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "MACIL";
	self->health = 95;
	self->spawnhealth = self->health;
	self->gibshealth = -47;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL|MF_UNUSED4;
	self->spawnstate = S_521;
	self->seestate = S_528;
	self->missilestate = S_541;
	self->painstate = S_539;
	self->deathstate = S_544;
	self->xdeathstate = S_544;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound47");
	self->sound_pain = GetSoundID("Sound12");
	self->sound_death = GetSoundID("Sound19");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_51
//
//==========================================================================

void misc_51(mobj_t *self, mthing_t *mthing)
{
	self->translucency = 66;
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_562;
	self->sound_sight = GetSoundID("Sound72");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_52
//
//==========================================================================

void misc_52(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 150;
	self->spawnhealth = self->health;
	self->gibshealth = -75;
	self->radius = 20.0;
	self->height = 60.0;
	self->mass = 500.0;
	self->speed = 420.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 128;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_569;
	self->seestate = S_571;
	self->meleestate = S_579;
	self->missilestate = S_582;
	self->painstate = S_584;
	self->deathstate = S_586;
	self->xdeathstate = S_595;
	self->sound_sight = GetSoundID("Sound91");
	self->sound_active = GetSoundID("Sound94");
	self->sound_pain = GetSoundID("Sound92");
	self->sound_death = GetSoundID("Sound93");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_53
//
//==========================================================================

void misc_53(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ACOLYTE";
	self->health = 70;
	self->spawnhealth = self->health;
	self->gibshealth = -35;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 400.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_602;
	self->seestate = S_614;
	self->missilestate = S_618;
	self->painstate = S_624;
	self->deathstate = S_625;
	self->xdeathstate = S_633;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound48");
	self->sound_attack = GetSoundID("Sound5");
	self->sound_pain = GetSoundID("Sound16");
	self->sound_death = GetSoundID("Sound21");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_54
//
//==========================================================================

void misc_54(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ACOLYTE";
	self->translation = 1;
	self->health = 70;
	self->spawnhealth = self->health;
	self->gibshealth = -35;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 400.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_602;
	self->seestate = S_614;
	self->missilestate = S_618;
	self->painstate = S_624;
	self->deathstate = S_625;
	self->xdeathstate = S_633;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound49");
	self->sound_attack = GetSoundID("Sound5");
	self->sound_pain = GetSoundID("Sound16");
	self->sound_death = GetSoundID("Sound21");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_55
//
//==========================================================================

void misc_55(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ACOLYTE";
	self->translation = 2;
	self->health = 70;
	self->spawnhealth = self->health;
	self->gibshealth = -35;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 400.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_602;
	self->seestate = S_614;
	self->missilestate = S_618;
	self->painstate = S_624;
	self->deathstate = S_625;
	self->xdeathstate = S_633;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound50");
	self->sound_attack = GetSoundID("Sound5");
	self->sound_pain = GetSoundID("Sound16");
	self->sound_death = GetSoundID("Sound21");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_56
//
//==========================================================================

void misc_56(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ACOLYTE";
	self->translation = 3;
	self->health = 70;
	self->spawnhealth = self->health;
	self->gibshealth = -35;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 400.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_602;
	self->seestate = S_614;
	self->missilestate = S_618;
	self->painstate = S_624;
	self->deathstate = S_625;
	self->xdeathstate = S_633;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound48");
	self->sound_attack = GetSoundID("Sound5");
	self->sound_pain = GetSoundID("Sound16");
	self->sound_death = GetSoundID("Sound21");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_57
//
//==========================================================================

void misc_57(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ACOLYTE";
	self->translation = 4;
	self->health = 70;
	self->spawnhealth = self->health;
	self->gibshealth = -35;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 400.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_602;
	self->seestate = S_614;
	self->missilestate = S_618;
	self->painstate = S_624;
	self->deathstate = S_625;
	self->xdeathstate = S_633;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound49");
	self->sound_attack = GetSoundID("Sound5");
	self->sound_pain = GetSoundID("Sound16");
	self->sound_death = GetSoundID("Sound21");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_58
//
//==========================================================================

void misc_58(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ACOLYTE";
	self->translation = 5;
	self->health = 70;
	self->spawnhealth = self->health;
	self->gibshealth = -35;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 400.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_602;
	self->seestate = S_614;
	self->missilestate = S_618;
	self->painstate = S_624;
	self->deathstate = S_625;
	self->xdeathstate = S_633;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound50");
	self->sound_attack = GetSoundID("Sound5");
	self->sound_pain = GetSoundID("Sound16");
	self->sound_death = GetSoundID("Sound21");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_59
//
//==========================================================================

void misc_59(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ACOLYTE";
	self->health = 70;
	self->spawnhealth = self->health;
	self->gibshealth = -35;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 400.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 150;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_COUNTKILL;
	self->spawnstate = S_602;
	self->seestate = S_613;
	self->missilestate = S_618;
	self->painstate = S_622;
	self->deathstate = S_625;
	self->xdeathstate = S_633;
	self->sound_sight = GetSoundID("Sound9");
	self->sound_active = GetSoundID("Sound49");
	self->sound_attack = GetSoundID("Sound5");
	self->sound_pain = GetSoundID("Sound16");
	self->sound_death = GetSoundID("Sound21");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_60
//
//==========================================================================

void misc_60(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 400;
	self->spawnhealth = self->health;
	self->radius = 40.0;
	self->height = 56.0;
	self->mass = 400.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 128;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_645;
	self->seestate = S_646;
	self->missilestate = S_654;
	self->painstate = S_664;
	self->deathstate = S_665;
	self->sound_sight = GetSoundID("Sound66");
	self->sound_active = GetSoundID("Sound67");
	self->sound_pain = GetSoundID("Sound64");
	self->sound_death = GetSoundID("Sound65");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_61
//
//==========================================================================

void misc_61(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 500;
	self->spawnhealth = self->health;
	self->radius = 40.0;
	self->height = 56.0;
	self->mass = 500.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 128;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_674;
	self->seestate = S_675;
	self->missilestate = S_683;
	self->painstate = S_685;
	self->deathstate = S_686;
	self->sound_sight = GetSoundID("Sound66");
	self->sound_active = GetSoundID("Sound67");
	self->sound_pain = GetSoundID("Sound64");
	self->sound_death = GetSoundID("Sound84");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_62
//
//==========================================================================

void misc_62(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Enforcer";
	self->health = 300;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 60.0;
	self->mass = 500.0;
	self->speed = 280.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 100;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_702;
	self->seestate = S_706;
	self->meleestate = S_714;
	self->missilestate = S_716;
	self->painstate = S_718;
	self->deathstate = S_720;
	self->sound_sight = GetSoundID("Sound82");
	self->sound_active = GetSoundID("Sound85");
	self->sound_pain = GetSoundID("Sound83");
	self->sound_death = GetSoundID("Sound84");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_63
//
//==========================================================================

void misc_63(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ORACLE";
	self->health = 31;
	self->spawnhealth = self->health;
	self->radius = 15.0;
	self->height = 56.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 200;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_740;
	self->painstate = S_741;
	self->crashstate = S_741;
	self->deathstate = S_748;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_64
//
//==========================================================================

void misc_64(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "PRIEST";
	self->health = 800;
	self->spawnhealth = self->health;
	self->radius = 15.0;
	self->height = 56.0;
	self->mass = 100.0;
	self->speed = 350.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_757;
	self->seestate = S_759;
	self->meleestate = S_767;
	self->missilestate = S_770;
	self->deathstate = S_773;
	self->sound_sight = GetSoundID("Sound112");
	self->sound_active = GetSoundID("Sound102");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound111");
	self->sound_death = GetSoundID("Sound19");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_65
//
//==========================================================================

void misc_65(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translucency = 66;
	self->health = 500;
	self->spawnhealth = self->health;
	self->radius = 64.0;
	self->height = 64.0;
	self->mass = 1000.0;
	self->speed = 350.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 250;
	self->flags = MF_SPECIAL|MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_COUNTKILL|MF_TRANSLATION2|MF_UNUSED4;
	self->spawnstate = S_797;
	self->seestate = S_799;
	self->meleestate = S_810;
	self->missilestate = S_813;
	self->painstate = S_816;
	self->deathstate = S_817;
	self->sound_sight = GetSoundID("Sound125");
	self->sound_active = GetSoundID("Sound127");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound126");
	self->sound_death = GetSoundID("Sound128");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_66
//
//==========================================================================

void misc_66(mobj_t *self, mthing_t *mthing)
{
	self->translucency = 66;
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_TRANSLATION2;
	self->spawnstate = S_834;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_67
//
//==========================================================================

void misc_67(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_843;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_68
//
//==========================================================================

void misc_68(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_850;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_69
//
//==========================================================================

void misc_69(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translucency = 66;
	self->health = 500;
	self->spawnhealth = self->health;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 1000.0;
	self->speed = 350.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 50;
	self->flags = MF_SPECIAL|MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_COUNTKILL|MF_TRANSLATION2|MF_UNUSED4;
	self->spawnstate = S_861;
	self->seestate = S_863;
	self->meleestate = S_874;
	self->missilestate = S_877;
	self->painstate = S_880;
	self->deathstate = S_817;
	self->sound_sight = GetSoundID("Sound125");
	self->sound_active = GetSoundID("Sound127");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound126");
	self->sound_death = GetSoundID("Sound128");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_70
//
//==========================================================================

void misc_70(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translucency = 66;
	self->health = 500;
	self->spawnhealth = self->health;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 1000.0;
	self->speed = 350.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 50;
	self->flags = MF_SPECIAL|MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_COUNTKILL|MF_TRANSLATION2|MF_UNUSED4;
	self->spawnstate = S_881;
	self->seestate = S_892;
	self->meleestate = S_903;
	self->missilestate = S_906;
	self->painstate = S_909;
	self->deathstate = S_817;
	self->sound_sight = GetSoundID("Sound125");
	self->sound_active = GetSoundID("Sound127");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound126");
	self->sound_death = GetSoundID("Sound128");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_71
//
//==========================================================================

void misc_71(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translucency = 66;
	self->health = 500;
	self->spawnhealth = self->health;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 1000.0;
	self->speed = 350.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 50;
	self->flags = MF_SPECIAL|MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_COUNTKILL|MF_TRANSLATION2|MF_UNUSED4;
	self->spawnstate = S_910;
	self->seestate = S_912;
	self->meleestate = S_923;
	self->missilestate = S_926;
	self->painstate = S_929;
	self->deathstate = S_817;
	self->sound_sight = GetSoundID("Sound125");
	self->sound_active = GetSoundID("Sound127");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound126");
	self->sound_death = GetSoundID("Sound128");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_72
//
//==========================================================================

void misc_72(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translucency = 66;
	self->health = 500;
	self->spawnhealth = self->health;
	self->radius = 24.0;
	self->height = 64.0;
	self->mass = 1000.0;
	self->speed = 350.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 50;
	self->flags = MF_SPECIAL|MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_COUNTKILL|MF_TRANSLATION2|MF_UNUSED4;
	self->spawnstate = S_930;
	self->seestate = S_932;
	self->meleestate = S_943;
	self->missilestate = S_946;
	self->painstate = S_949;
	self->deathstate = S_817;
	self->sound_sight = GetSoundID("Sound125");
	self->sound_active = GetSoundID("Sound127");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound126");
	self->sound_death = GetSoundID("Sound128");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_73
//
//==========================================================================

void misc_73(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translucency = 66;
	self->health = 1500;
	self->spawnhealth = self->health;
	self->radius = 130.0;
	self->height = 200.0;
	self->mass = 1000.0;
	self->speed = 350.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 255;
	self->flags = MF_SPECIAL|MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_COUNTKILL|MF_TRANSLATION2|MF_UNUSED4;
	self->spawnstate = S_950;
	self->seestate = S_964;
	self->meleestate = S_975;
	self->missilestate = S_978;
	self->painstate = S_981;
	self->deathstate = S_982;
	self->sound_sight = GetSoundID("Sound124");
	self->sound_active = GetSoundID("Sound127");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound126");
	self->sound_death = GetSoundID("Sound129");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_74
//
//==========================================================================

void misc_74(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->translucency = 66;
	self->health = 100;
	self->spawnhealth = self->health;
	self->radius = 130.0;
	self->height = 200.0;
	self->mass = 1000.0;
	self->speed = 455.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 255;
	self->flags = MF_SPECIAL|MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_COUNTKILL|MF_TRANSLATION2|MF_UNUSED4;
	self->spawnstate = S_988;
	self->seestate = S_989;
	self->meleestate = S_995;
	self->missilestate = S_998;
	self->painstate = S_1001;
	self->deathstate = S_1002;
	self->sound_sight = GetSoundID("Sound125");
	self->sound_active = GetSoundID("Sound127");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound126");
	self->sound_death = GetSoundID("Sound128");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_75
//
//==========================================================================

void misc_75(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 84.0;
	self->height = 47.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1017;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_76
//
//==========================================================================

void misc_76(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 25.0;
	self->height = 91.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1018;
	self->seestate = S_1019;
	self->sound_sight = GetSoundID("Sound19");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_77
//
//==========================================================================

void misc_77(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 1050.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 70;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1024;
	self->deathstate = S_149;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_78
//
//==========================================================================

void misc_78(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 1050.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 20;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1024;
	self->deathstate = S_149;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_79
//
//==========================================================================

void misc_79(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 1050.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 70;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1027;
	self->deathstate = S_149;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_80
//
//==========================================================================

void misc_80(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 1050.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 20;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1027;
	self->deathstate = S_149;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_81
//
//==========================================================================

void misc_81(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 1050.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 10;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1024;
	self->deathstate = S_149;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_82
//
//==========================================================================

void misc_82(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF;
	self->spawnstate = S_1032;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_83
//
//==========================================================================

void misc_83(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 40.0;
	self->mass = 100.0;
	self->speed = 630.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 130;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1035;
	self->deathstate = S_149;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_84
//
//==========================================================================

void misc_84(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 40.0;
	self->mass = 100.0;
	self->speed = 630.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 30;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1035;
	self->deathstate = S_149;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_85
//
//==========================================================================

void misc_85(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 24.0;
	self->mass = 100.0;
	self->speed = 770.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 100;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1040;
	self->deathstate = S_153;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_86
//
//==========================================================================

void misc_86(mobj_t *self, mthing_t *mthing)
{
	self->translucency = 66;
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 630.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 90;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1045;
	self->deathstate = S_148;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_87
//
//==========================================================================

void misc_87(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 980.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 120;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1049;
	self->deathstate = S_148;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_88
//
//==========================================================================

void misc_88(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 980.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 60;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE|MF_UNUSED4;
	self->spawnstate = S_1049;
	self->deathstate = S_148;
	self->sound_sight = GetSoundID("Sound106");
	self->sound_death = GetSoundID("Sound107");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_89
//
//==========================================================================

void misc_89(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 100;
	self->spawnhealth = self->health;
	self->radius = 23.0;
	self->height = 53.0;
	self->mass = 300.0;
	self->speed = 245.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 255;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_SPAWNCEILING|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_TELEPORT|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_1054;
	self->seestate = S_1055;
	self->missilestate = S_1056;
	self->painstate = S_1059;
	self->deathstate = S_1060;
	self->sound_sight = GetSoundID("Sound78");
	self->sound_active = GetSoundID("Sound80");
	self->sound_death = GetSoundID("Sound79");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_90
//
//==========================================================================

void misc_90(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 80;
	self->spawnhealth = self->health;
	self->radius = 31.0;
	self->height = 25.0;
	self->mass = 100.0;
	self->speed = 560.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 40;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_SPAWNCEILING|MF_NOGRAVITY|MF_DROPOFF|MF_TELEPORT|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_1067;
	self->seestate = S_1070;
	self->meleestate = S_1076;
	self->painstate = S_1091;
	self->deathstate = S_1092;
	self->sound_sight = GetSoundID("Sound95");
	self->sound_active = GetSoundID("Sound95");
	self->sound_attack = GetSoundID("Sound98");
	self->sound_pain = GetSoundID("Sound98");
	self->sound_death = GetSoundID("Sound97");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_91
//
//==========================================================================

void misc_91(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 40.0;
	self->height = 110.0;
	self->mass = 1000.0;
	self->speed = 420.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_DROPOFF|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_1105;
	self->seestate = S_1107;
	self->missilestate = S_1115;
	self->deathstate = S_1125;
	self->sound_sight = GetSoundID("Sound116");
	self->sound_active = GetSoundID("Sound115");
	self->sound_death = GetSoundID("Sound114");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_92
//
//==========================================================================

void misc_92(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 1100;
	self->spawnhealth = self->health;
	self->radius = 45.0;
	self->height = 60.0;
	self->mass = 800.0;
	self->speed = 910.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 64;
	self->damage = 4;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_NOGRAVITY|MF_PICKUP|MF_FLOAT|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_1146;
	self->seestate = S_1148;
	self->meleestate = S_1156;
	self->missilestate = S_1160;
	self->painstate = S_1164;
	self->deathstate = S_1166;
	self->sound_active = GetSoundID("Sound110");
	self->sound_attack = GetSoundID("Sound90");
	self->sound_pain = GetSoundID("Sound109");
	self->sound_death = GetSoundID("Sound65");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_93
//
//==========================================================================

void misc_93(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOBLOOD;
	self->spawnstate = S_1180;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_94
//
//==========================================================================

void misc_94(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 14.0;
	self->mass = 100.0;
	self->speed = 700.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 2;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_240;
	self->deathstate = S_241;
	self->sound_sight = GetSoundID("Sound101");
	self->sound_active = GetSoundID("Sound1");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_95
//
//==========================================================================

void misc_95(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_242;
	self->sound_sight = GetSoundID("Sound102");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_96
//
//==========================================================================

void misc_96(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 14.0;
	self->mass = 100.0;
	self->speed = 700.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 10;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_243;
	self->deathstate = S_262;
	self->sound_sight = GetSoundID("Sound71");
	self->sound_death = GetSoundID("Sound6");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_97
//
//==========================================================================

void misc_97(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 14.0;
	self->mass = 100.0;
	self->speed = 700.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 7;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_243;
	self->deathstate = S_261;
	self->sound_sight = GetSoundID("Sound71");
	self->sound_death = GetSoundID("Sound6");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_98
//
//==========================================================================

void misc_98(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 14.0;
	self->mass = 100.0;
	self->speed = 700.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 10;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_244;
	self->deathstate = S_262;
	self->sound_sight = GetSoundID("Sound71");
	self->sound_death = GetSoundID("Sound6");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_99
//
//==========================================================================

void misc_99(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 10.0;
	self->mass = 100.0;
	self->speed = 1050.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 10;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_246;
	self->deathstate = S_148;
	self->sound_sight = GetSoundID("Sound1");
	self->sound_active = GetSoundID("Sound1");
	self->sound_death = GetSoundID("Sound68");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_100
//
//==========================================================================

void misc_100(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 10.0;
	self->mass = 100.0;
	self->speed = 1050.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 500;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_247;
	self->deathstate = S_248;
	self->sound_sight = GetSoundID("Sound1");
	self->sound_active = GetSoundID("Sound1");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_101
//
//==========================================================================

void misc_101(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 8.0;
	self->mass = 100.0;
	self->speed = 1400.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_173;
	self->deathstate = S_135;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_102
//
//==========================================================================

void misc_102(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 8.0;
	self->mass = 100.0;
	self->speed = 1400.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 1;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_173;
	self->deathstate = S_131;
	self->sound_sight = GetSoundID("Sound88");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_103
//
//==========================================================================

void misc_103(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 13.0;
	self->height = 13.0;
	self->mass = 20.0;
	self->speed = 525.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 30;
	self->damage = 1;
	self->flags = MF_NOBLOCKMAP|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_179;
	self->deathstate = S_194;
	self->sound_sight = GetSoundID("Sound103");
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_104
//
//==========================================================================

void misc_104(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 13.0;
	self->height = 13.0;
	self->mass = 20.0;
	self->speed = 525.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 40;
	self->damage = 1;
	self->flags = MF_NOBLOCKMAP|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_177;
	self->deathstate = S_216;
	self->sound_sight = GetSoundID("Sound103");
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_105
//
//==========================================================================

void misc_105(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 13.0;
	self->height = 13.0;
	self->mass = 20.0;
	self->speed = 525.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 40;
	self->damage = 1;
	self->flags = MF_NOBLOCKMAP|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_181;
	self->deathstate = S_230;
	self->sound_sight = GetSoundID("Sound103");
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_106
//
//==========================================================================

void misc_106(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 13.0;
	self->height = 13.0;
	self->mass = 15.0;
	self->speed = 875.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 15;
	self->flags = MF_NOBLOCKMAP|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_183;
	self->deathstate = S_185;
	self->sound_sight = GetSoundID("Sound103");
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_107
//
//==========================================================================

void misc_107(mobj_t *self, mthing_t *mthing)
{
	self->translucency = 66;
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 80;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_TRANSLATION2;
	self->spawnstate = S_231;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_108
//
//==========================================================================

void misc_108(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 120;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_217;
	self->deathstate = S_226;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_109
//
//==========================================================================

void misc_109(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 13.0;
	self->height = 8.0;
	self->mass = 100.0;
	self->speed = 700.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 1;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_249;
	self->deathstate = S_253;
	self->sound_sight = GetSoundID("Sound87");
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_110
//
//==========================================================================

void misc_110(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 13.0;
	self->height = 13.0;
	self->mass = 100.0;
	self->speed = 1225.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 10;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_258;
	self->deathstate = S_260;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_111
//
//==========================================================================

void misc_111(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 11.0;
	self->mass = 10.0;
	self->speed = 525.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 3;
	self->flags = MF_NOBLOCKMAP|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_1188;
	self->deathstate = S_1190;
	self->sound_sight = GetSoundID("Sound7");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_112
//
//==========================================================================

void misc_112(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 11.0;
	self->mass = 50.0;
	self->speed = 1225.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->damage = 1;
	self->flags = MF_NOBLOCKMAP|MF_DROPOFF|MF_MISSILE;
	self->spawnstate = S_1188;
	self->deathstate = S_1190;
	self->sound_sight = GetSoundID("Sound7");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_113
//
//==========================================================================

void misc_113(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_175;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_114
//
//==========================================================================

void misc_114(mobj_t *self, mthing_t *mthing)
{
	self->translucency = 66;
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_PUFF1;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_115
//
//==========================================================================

void misc_115(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_140;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_116
//
//==========================================================================

void misc_116(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_159;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_teleport_fog
//
//==========================================================================

void misc_teleport_fog(mobj_t *self, mthing_t *mthing)
{
	self->translucency = 66;
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_TFOG1;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_item_respawn_fog
//
//==========================================================================

void misc_item_respawn_fog(mobj_t *self, mthing_t *mthing)
{
	self->translucency = 66;
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOGRAVITY;
	self->spawnstate = S_IFOG1;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_teleport_spot
//
//==========================================================================

void misc_teleport_spot(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOSECTOR|MF_NOBLOCKMAP;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_120
//
//==========================================================================

void misc_120(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 60;
	self->flags = MF_NOBLOCKMAP|MF_AMBUSH|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1196;
	self->seestate = S_1197;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_121
//
//==========================================================================

void misc_121(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->health = 125;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 10000000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SHOOTABLE|MF_AMBUSH|MF_SPAWNCEILING|MF_NOGRAVITY|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_1199;
	self->seestate = S_1200;
	self->missilestate = S_1201;
	self->painstate = S_1201;
	self->deathstate = S_1204;
	self->sound_death = GetSoundID("Sound6");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_122
//
//==========================================================================

void misc_122(mobj_t *self, mthing_t *mthing)
{
	self->health = 100;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 76.0;
	self->mass = 10000000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD;
	self->spawnstate = S_1210;
	self->deathstate = S_1212;
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_123
//
//==========================================================================

void misc_123(mobj_t *self, mthing_t *mthing)
{
	self->health = 80;
	self->spawnhealth = self->health;
	self->radius = 26.0;
	self->height = 128.0;
	self->mass = 100000.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD;
	self->spawnstate = S_1221;
	self->deathstate = S_1225;
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_124
//
//==========================================================================

void misc_124(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Med_patch";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 20.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1429;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_125
//
//==========================================================================

void misc_125(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Medical_kit";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 15.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1430;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_126
//
//==========================================================================

void misc_126(mobj_t *self, mthing_t *mthing)
{
	self->classname = "full_health";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 5.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1298;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_127
//
//==========================================================================

void misc_127(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Thalite_Ore";
	self->health = 10;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 16.0;
	self->mass = 4.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL|MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD;
	self->spawnstate = S_1239;
	self->deathstate = S_1240;
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_128
//
//==========================================================================

void misc_128(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Metal_Armor";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 3.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1348;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_129
//
//==========================================================================

void misc_129(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Leather_Armor";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 5.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1349;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_130
//
//==========================================================================

void misc_130(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1401;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_131
//
//==========================================================================

void misc_131(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1402;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_132
//
//==========================================================================

void misc_132(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Base_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_133
//
//==========================================================================

void misc_133(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Rebel_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_134
//
//==========================================================================

void misc_134(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Passcard";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1405;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_135
//
//==========================================================================

void misc_135(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ID_Badge";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1403;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_136
//
//==========================================================================

void misc_136(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Prison_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1416;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_137
//
//==========================================================================

void misc_137(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Severed_Hand";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1409;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_138
//
//==========================================================================

void misc_138(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Power1_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1417;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_139
//
//==========================================================================

void misc_139(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Power2_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1418;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_140
//
//==========================================================================

void misc_140(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Power3_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1419;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_141
//
//==========================================================================

void misc_141(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Gold_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1406;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_142
//
//==========================================================================

void misc_142(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "ID_Card";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1404;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_143
//
//==========================================================================

void misc_143(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Silver_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1407;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_144
//
//==========================================================================

void misc_144(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Oracle_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1420;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_145
//
//==========================================================================

void misc_145(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Military_ID";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1421;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_146
//
//==========================================================================

void misc_146(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Order_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1422;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_147
//
//==========================================================================

void misc_147(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Warehouse_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1423;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_148
//
//==========================================================================

void misc_148(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Brass_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1408;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_149
//
//==========================================================================

void misc_149(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Red_Crystal_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1424;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_150
//
//==========================================================================

void misc_150(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Blue_Crystal_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1425;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_151
//
//==========================================================================

void misc_151(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Chapel_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1426;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_152
//
//==========================================================================

void misc_152(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Tunnel_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1427;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_153
//
//==========================================================================

void misc_153(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Security_Key";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1428;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_154
//
//==========================================================================

void misc_154(mobj_t *self, mthing_t *mthing)
{
	self->classname = "New_Key1";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1428;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_155
//
//==========================================================================

void misc_155(mobj_t *self, mthing_t *mthing)
{
	self->classname = "New_Key2";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1428;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_156
//
//==========================================================================

void misc_156(mobj_t *self, mthing_t *mthing)
{
	self->classname = "New_Key3";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1428;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_157
//
//==========================================================================

void misc_157(mobj_t *self, mthing_t *mthing)
{
	self->classname = "New_Key4";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1428;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_158
//
//==========================================================================

void misc_158(mobj_t *self, mthing_t *mthing)
{
	self->classname = "New_Key5";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1428;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_159
//
//==========================================================================

void misc_159(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Shadow_armor";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 2.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1435;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_160
//
//==========================================================================

void misc_160(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Environmental_Suit";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 5.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1439;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_161
//
//==========================================================================

void misc_161(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Guard_Uniform";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1440;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_162
//
//==========================================================================

void misc_162(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Officer's_Uniform";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1441;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_163
//
//==========================================================================

void misc_163(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Map";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1442;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_164
//
//==========================================================================

void misc_164(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Map-Radar";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1444;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_165
//
//==========================================================================

void misc_165(mobj_t *self, mthing_t *mthing)
{
	self->classname = "coin";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 99999.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL|MF_DROPPED;
	self->spawnstate = S_1431;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_166
//
//==========================================================================

void misc_166(mobj_t *self, mthing_t *mthing)
{
	self->classname = "10_gold";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL|MF_DROPPED;
	self->spawnstate = S_1432;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_167
//
//==========================================================================

void misc_167(mobj_t *self, mthing_t *mthing)
{
	self->classname = "25_gold";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL|MF_DROPPED;
	self->spawnstate = S_1433;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_168
//
//==========================================================================

void misc_168(mobj_t *self, mthing_t *mthing)
{
	self->classname = "50_gold";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL|MF_DROPPED;
	self->spawnstate = S_1434;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_169
//
//==========================================================================

void misc_169(mobj_t *self, mthing_t *mthing)
{
	self->classname = "ring";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1241;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_170
//
//==========================================================================

void misc_170(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Offering_Chalice";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL|MF_DROPPED;
	self->spawnstate = S_1460;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_171
//
//==========================================================================

void misc_171(mobj_t *self, mthing_t *mthing)
{
	self->classname = "ear";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1242;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_172
//
//==========================================================================

void misc_172(mobj_t *self, mthing_t *mthing)
{
	if (deathmatch)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "Communicator";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1243;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_173
//
//==========================================================================

void misc_173(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Targeter";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1244;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_174
//
//==========================================================================

void misc_174(mobj_t *self, mthing_t *mthing)
{
	self->classname = "HE-Grenade_Rounds";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1456;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_175
//
//==========================================================================

void misc_175(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Fire-Grenade_Rounds";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1457;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_176
//
//==========================================================================

void misc_176(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Gas-Grenade_Rounds";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1458;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_177
//
//==========================================================================

void misc_177(mobj_t *self, mthing_t *mthing)
{
	self->classname = "bullets";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1446;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_178
//
//==========================================================================

void misc_178(mobj_t *self, mthing_t *mthing)
{
	self->classname = "ammo";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1447;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_179
//
//==========================================================================

void misc_179(mobj_t *self, mthing_t *mthing)
{
	self->classname = "rocket";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1448;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_180
//
//==========================================================================

void misc_180(mobj_t *self, mthing_t *mthing)
{
	self->classname = "box_of_rockets";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1449;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_181
//
//==========================================================================

void misc_181(mobj_t *self, mthing_t *mthing)
{
	self->classname = "energy_pod";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1450;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_182
//
//==========================================================================

void misc_182(mobj_t *self, mthing_t *mthing)
{
	self->classname = "energy_pack";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1452;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_183
//
//==========================================================================

void misc_183(mobj_t *self, mthing_t *mthing)
{
	self->classname = "poison_arrows";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1454;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_184
//
//==========================================================================

void misc_184(mobj_t *self, mthing_t *mthing)
{
	self->classname = "electric_arrows";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1455;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_185
//
//==========================================================================

void misc_185(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Back_pack";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1459;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_186
//
//==========================================================================

void misc_186(mobj_t *self, mthing_t *mthing)
{
	self->classname = "assault_gun";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1461;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_187
//
//==========================================================================

void misc_187(mobj_t *self, mthing_t *mthing)
{
	self->classname = "pulse_rifle";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1462;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_188
//
//==========================================================================

void misc_188(mobj_t *self, mthing_t *mthing)
{
	self->classname = "flame_thrower";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1463;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_189
//
//==========================================================================

void misc_189(mobj_t *self, mthing_t *mthing)
{
	self->classname = "flame_thrower_Parts";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1464;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_190
//
//==========================================================================

void misc_190(mobj_t *self, mthing_t *mthing)
{
	self->classname = "missile_gun";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1465;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_191
//
//==========================================================================

void misc_191(mobj_t *self, mthing_t *mthing)
{
	self->classname = "blaster";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1466;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_192
//
//==========================================================================

void misc_192(mobj_t *self, mthing_t *mthing)
{
	self->classname = "crossbow";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1468;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_193
//
//==========================================================================

void misc_193(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Grenade_launcher";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1467;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_194
//
//==========================================================================

void misc_194(mobj_t *self, mthing_t *mthing)
{
	self->classname = "SIGIL";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1469;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_195
//
//==========================================================================

void misc_195(mobj_t *self, mthing_t *mthing)
{
	self->classname = "SIGIL";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1470;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_196
//
//==========================================================================

void misc_196(mobj_t *self, mthing_t *mthing)
{
	self->classname = "SIGIL";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1471;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_197
//
//==========================================================================

void misc_197(mobj_t *self, mthing_t *mthing)
{
	self->classname = "SIGIL";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1472;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_198
//
//==========================================================================

void misc_198(mobj_t *self, mthing_t *mthing)
{
	self->classname = "SIGIL";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1473;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_199
//
//==========================================================================

void misc_199(mobj_t *self, mthing_t *mthing)
{
	self->health = 50;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_NOBLOOD;
	self->spawnstate = S_1410;
	self->deathstate = S_1245;
	self->sound_active = GetSoundID("Sound130");
	self->sound_death = GetSoundID("Sound104");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_200
//
//==========================================================================

void misc_200(mobj_t *self, mthing_t *mthing)
{
	if (nomonsters)
	{
		RemoveMobjThinker(self);
		return;
	}
	self->classname = "rat_buddy";
	self->health = 5;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 16.0;
	self->mass = 100.0;
	self->speed = 455.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SHOOTABLE|MF_NOBLOOD|MF_COUNTKILL;
	self->spawnstate = S_1270;
	self->seestate = S_1271;
	self->meleestate = S_1275;
	self->deathstate = S_1316;
	self->sound_sight = GetSoundID("Sound55");
	self->sound_active = GetSoundID("Sound55");
	self->sound_death = GetSoundID("Sound55");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_201
//
//==========================================================================

void misc_201(mobj_t *self, mthing_t *mthing)
{
	self->health = 10;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 32.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD;
	self->spawnstate = S_1350;
	self->deathstate = S_1351;
	self->sound_death = GetSoundID("Sound60");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_202
//
//==========================================================================

void misc_202(mobj_t *self, mthing_t *mthing)
{
	self->health = 30;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 32.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD;
	self->spawnstate = S_1358;
	self->deathstate = S_1359;
	self->sound_death = GetSoundID("Sound105");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_203
//
//==========================================================================

void misc_203(mobj_t *self, mthing_t *mthing)
{
	self->health = 99999999;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 72.0;
	self->mass = 9999999.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->painchance = 255;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_NOBLOOD;
	self->spawnstate = S_1277;
	self->painstate = S_1278;
	self->sound_pain = GetSoundID("Sound3");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_204
//
//==========================================================================

void misc_204(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 4.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1477;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_205
//
//==========================================================================

void misc_205(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 4.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1478;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_206
//
//==========================================================================

void misc_206(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 4.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1479;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_207
//
//==========================================================================

void misc_207(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1474;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_208
//
//==========================================================================

void misc_208(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 128.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1551;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_209
//
//==========================================================================

void misc_209(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 128.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1552;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_210
//
//==========================================================================

void misc_210(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 80.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1553;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_211
//
//==========================================================================

void misc_211(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 40.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1554;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_212
//
//==========================================================================

void misc_212(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 24.0;
	self->height = 192.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1555;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_213
//
//==========================================================================

void misc_213(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 24.0;
	self->height = 192.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1518;
	self->sound_active = GetSoundID("Sound119");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_214
//
//==========================================================================

void misc_214(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 54.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1561;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_215
//
//==========================================================================

void misc_215(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 40.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1559;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_216
//
//==========================================================================

void misc_216(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 40.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1560;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_217
//
//==========================================================================

void misc_217(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 128.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1562;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_218
//
//==========================================================================

void misc_218(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 128.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1563;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_219
//
//==========================================================================

void misc_219(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 25.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1564;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_220
//
//==========================================================================

void misc_220(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1475;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_221
//
//==========================================================================

void misc_221(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 40.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1476;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_222
//
//==========================================================================

void misc_222(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1520;
	self->sound_active = GetSoundID("Sound45");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_223
//
//==========================================================================

void misc_223(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1532;
	self->sound_active = GetSoundID("Sound44");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_224
//
//==========================================================================

void misc_224(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 1.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1528;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_225
//
//==========================================================================

void misc_225(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1540;
	self->sound_active = GetSoundID("Sound46");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_226
//
//==========================================================================

void misc_226(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 56.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1544;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_227
//
//==========================================================================

void misc_227(mobj_t *self, mthing_t *mthing)
{
	self->translucency = 66;
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1547;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_228
//
//==========================================================================

void misc_228(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_673;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_229
//
//==========================================================================

void misc_229(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_PLAY_DIE10;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_230
//
//==========================================================================

void misc_230(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_409;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_231
//
//==========================================================================

void misc_231(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_632;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_232
//
//==========================================================================

void misc_232(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_594;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_233
//
//==========================================================================

void misc_233(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_512;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_234
//
//==========================================================================

void misc_234(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_425;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_235
//
//==========================================================================

void misc_235(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1280;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_236
//
//==========================================================================

void misc_236(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 32.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1372;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_237
//
//==========================================================================

void misc_237(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1376;
	self->sound_active = GetSoundID("Sound23");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_238
//
//==========================================================================

void misc_238(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 32.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1380;
	self->sound_active = GetSoundID("Sound23");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_239
//
//==========================================================================

void misc_239(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 0.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1384;
	self->sound_active = GetSoundID("Sound23");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_240
//
//==========================================================================

void misc_240(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 0.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1400;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_241
//
//==========================================================================

void misc_241(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 93.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1496;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_242
//
//==========================================================================

void misc_242(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 3.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1500;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_243
//
//==========================================================================

void misc_243(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 64.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1497;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_244
//
//==========================================================================

void misc_244(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 56.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1498;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_245
//
//==========================================================================

void misc_245(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 4.0;
	self->height = 72.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1388;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_246
//
//==========================================================================

void misc_246(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 3.0;
	self->height = 80.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1370;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_247
//
//==========================================================================

void misc_247(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 3.0;
	self->height = 80.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1371;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_248
//
//==========================================================================

void misc_248(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1480;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_249
//
//==========================================================================

void misc_249(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1481;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_250
//
//==========================================================================

void misc_250(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1482;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_251
//
//==========================================================================

void misc_251(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1483;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_252
//
//==========================================================================

void misc_252(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1484;
	self->sound_active = GetSoundID("Sound43");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_253
//
//==========================================================================

void misc_253(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1488;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_254
//
//==========================================================================

void misc_254(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1489;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_255
//
//==========================================================================

void misc_255(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1490;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_256
//
//==========================================================================

void misc_256(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1491;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_257
//
//==========================================================================

void misc_257(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1492;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_258
//
//==========================================================================

void misc_258(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1493;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_259
//
//==========================================================================

void misc_259(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1494;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_260
//
//==========================================================================

void misc_260(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1495;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_261
//
//==========================================================================

void misc_261(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1499;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_262
//
//==========================================================================

void misc_262(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 72.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1392;
	self->sound_active = GetSoundID("Sound23");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_263
//
//==========================================================================

void misc_263(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 10.0;
	self->height = 80.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1396;
	self->sound_active = GetSoundID("Sound23");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_264
//
//==========================================================================

void misc_264(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 15.0;
	self->height = 109.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1501;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_265
//
//==========================================================================

void misc_265(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 15.0;
	self->height = 109.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1502;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_266
//
//==========================================================================

void misc_266(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 15.0;
	self->height = 64.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1503;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_267
//
//==========================================================================

void misc_267(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 15.0;
	self->height = 80.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1504;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_268
//
//==========================================================================

void misc_268(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 15.0;
	self->height = 40.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1505;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_269
//
//==========================================================================

void misc_269(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 64.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1506;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_270
//
//==========================================================================

void misc_270(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 64.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1507;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_271
//
//==========================================================================

void misc_271(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 128.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1508;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_272
//
//==========================================================================

void misc_272(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 12.0;
	self->height = 24.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1509;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_273
//
//==========================================================================

void misc_273(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 12.0;
	self->height = 32.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1510;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_274
//
//==========================================================================

void misc_274(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 6.0;
	self->height = 24.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1511;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_275
//
//==========================================================================

void misc_275(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1512;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_276
//
//==========================================================================

void misc_276(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1513;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_277
//
//==========================================================================

void misc_277(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 32.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1514;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_278
//
//==========================================================================

void misc_278(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 11.0;
	self->height = 64.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1515;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_279
//
//==========================================================================

void misc_279(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 8.0;
	self->height = 64.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1516;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_280
//
//==========================================================================

void misc_280(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 24.0;
	self->height = 40.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1517;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_281
//
//==========================================================================

void misc_281(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 12.0;
	self->height = 24.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1519;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_282
//
//==========================================================================

void misc_282(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 24.0;
	self->height = 96.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1281;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_283
//
//==========================================================================

void misc_283(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1282;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_284
//
//==========================================================================

void misc_284(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1283;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_285
//
//==========================================================================

void misc_285(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP;
	self->spawnstate = S_1284;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_286
//
//==========================================================================

void misc_286(mobj_t *self, mthing_t *mthing)
{
	self->health = 40;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 24.0;
	self->mass = 999999.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SHOOTABLE|MF_TELEPORT|MF_DROPPED|MF_NOBLOOD;
	self->spawnstate = S_1285;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_287
//
//==========================================================================

void misc_287(mobj_t *self, mthing_t *mthing)
{
	self->classname = "POWER_COUPLING";
	self->health = 40;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 16.0;
	self->mass = 1.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL|MF_DROPPED;
	self->spawnstate = S_1287;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_288
//
//==========================================================================

void misc_288(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 128.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1288;
	self->sound_active = GetSoundID("Sound122");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_289
//
//==========================================================================

void misc_289(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 72.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1289;
	self->sound_active = GetSoundID("Sound123");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_290
//
//==========================================================================

void misc_290(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 72.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID|MF_SPAWNCEILING|MF_NOGRAVITY;
	self->spawnstate = S_1289;
	self->sound_active = GetSoundID("Sound121");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_291
//
//==========================================================================

void misc_291(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 128.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1291;
	self->sound_active = GetSoundID("Sound120");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_292
//
//==========================================================================

void misc_292(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 32.0;
	self->height = 56.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SOLID;
	self->spawnstate = S_1292;
	self->sound_active = GetSoundID("Sound118");
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_293
//
//==========================================================================

void misc_293(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Teleportor_Beacon";
	self->health = 5;
	self->spawnhealth = self->health;
	self->radius = 16.0;
	self->height = 16.0;
	self->mass = 3.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL|MF_DROPPED;
	self->spawnstate = S_1345;
	self->seestate = S_1346;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_294
//
//==========================================================================

void misc_294(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1300;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_295
//
//==========================================================================

void misc_295(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1320;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_296
//
//==========================================================================

void misc_296(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_NOBLOCKMAP|MF_NOCLIP;
	self->spawnstate = S_1340;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_297
//
//==========================================================================

void misc_297(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Ammo";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_298
//
//==========================================================================

void misc_298(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Health";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_299
//
//==========================================================================

void misc_299(mobj_t *self, mthing_t *mthing)
{
	self->classname = "info";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_300
//
//==========================================================================

void misc_300(mobj_t *self, mthing_t *mthing)
{
	self->classname = "alarm";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_301
//
//==========================================================================

void misc_301(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_302
//
//==========================================================================

void misc_302(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_303
//
//==========================================================================

void misc_303(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Prison_pass";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_304
//
//==========================================================================

void misc_304(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_305
//
//==========================================================================

void misc_305(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_306
//
//==========================================================================

void misc_306(mobj_t *self, mthing_t *mthing)
{
	self->classname = "report";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_307
//
//==========================================================================

void misc_307(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Toughness";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1296;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_308
//
//==========================================================================

void misc_308(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Accuracy";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1297;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_309
//
//==========================================================================

void misc_309(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Oracle_Pass";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->flags = MF_SPECIAL;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_310
//
//==========================================================================

void misc_310(mobj_t *self, mthing_t *mthing)
{
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_311
//
//==========================================================================

void misc_311(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Blown_Up_the_Crystal";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_312
//
//==========================================================================

void misc_312(mobj_t *self, mthing_t *mthing)
{
	self->classname = "Blown_Up_the_Gates";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_313
//
//==========================================================================

void misc_313(mobj_t *self, mthing_t *mthing)
{
	self->classname = "quest4";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_314
//
//==========================================================================

void misc_314(mobj_t *self, mthing_t *mthing)
{
	self->classname = "quest5";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

//==========================================================================
//
//	misc_315
//
//==========================================================================

void misc_315(mobj_t *self, mthing_t *mthing)
{
	self->classname = "quest6";
	self->health = 1000;
	self->spawnhealth = self->health;
	self->radius = 20.0;
	self->height = 16.0;
	self->mass = 100.0;
	if (gameskill != sk_nightmare)
		self->reactiontime = 8;
	self->spawnstate = S_1295;
	generic_mobj_start(self, mthing);
}

__mobjinfo__
{
	MT_0 { 25, misc_0 }
	MT_PLAYER { -1, misc_player }
	MT_MERCHANDER1 { 116, npc_merchander1 }
	MT_MERCHANDER2 { 72, npc_merchander2 }
	MT_MERCHANDER3 { 73, npc_merchander3 }
	MT_MERCHANDER4 { 74, npc_merchander4 }
	MT_6 { 3004, misc_6 }
	MT_7 { 130, misc_7 }
	MT_8 { 131, misc_8 }
	MT_9 { 65, misc_9 }
	MT_10 { 132, misc_10 }
	MT_11 { 133, misc_11 }
	MT_12 { 66, misc_12 }
	MT_13 { 134, misc_13 }
	MT_14 { 135, misc_14 }
	MT_15 { 67, misc_15 }
	MT_16 { 136, misc_16 }
	MT_17 { 137, misc_17 }
	MT_18 { 172, misc_18 }
	MT_19 { 173, misc_19 }
	MT_20 { 174, misc_20 }
	MT_21 { 175, misc_21 }
	MT_22 { 176, misc_22 }
	MT_23 { 177, misc_23 }
	MT_24 { 178, misc_24 }
	MT_25 { 179, misc_25 }
	MT_26 { 180, misc_26 }
	MT_27 { 181, misc_27 }
	MT_28 { 169, misc_28 }
	MT_29 { 201, misc_29 }
	MT_30 { 170, misc_30 }
	MT_31 { 209, misc_31 }
	MT_32 { 210, misc_32 }
	MT_33 { 211, misc_33 }
	MT_34 { 213, misc_34 }
	MT_35 { 214, misc_35 }
	MT_36 { 229, misc_36 }
	MT_37 { 204, misc_37 }
	MT_38 { 141, misc_38 }
	MT_39 { 155, misc_39 }
	MT_40 { 156, misc_40 }
	MT_41 { 157, misc_41 }
	MT_42 { 158, misc_42 }
	MT_43 { 9, misc_43 }
	MT_44 { 144, misc_44 }
	MT_45 { 145, misc_45 }
	MT_46 { 149, misc_46 }
	MT_47 { 150, misc_47 }
	MT_48 { 151, misc_48 }
	MT_49 { 64, misc_49 }
	MT_50 { 200, misc_50 }
	MT_51 { -1, misc_51 }
	MT_52 { 3001, misc_52 }
	MT_53 { 3002, misc_53 }
	MT_54 { 142, misc_54 }
	MT_55 { 143, misc_55 }
	MT_56 { 146, misc_56 }
	MT_57 { 147, misc_57 }
	MT_58 { 148, misc_58 }
	MT_59 { 58, misc_59 }
	MT_60 { 3005, misc_60 }
	MT_61 { 187, misc_61 }
	MT_62 { 3003, misc_62 }
	MT_63 { 199, misc_63 }
	MT_64 { 12, misc_64 }
	MT_65 { 129, misc_65 }
	MT_66 { -1, misc_66 }
	MT_67 { -1, misc_67 }
	MT_68 { -1, misc_68 }
	MT_69 { 75, misc_69 }
	MT_70 { 76, misc_70 }
	MT_71 { 167, misc_71 }
	MT_72 { 168, misc_72 }
	MT_73 { 128, misc_73 }
	MT_74 { -1, misc_74 }
	MT_75 { 26, misc_75 }
	MT_76 { 198, misc_76 }
	MT_77 { -1, misc_77 }
	MT_78 { -1, misc_78 }
	MT_79 { -1, misc_79 }
	MT_80 { -1, misc_80 }
	MT_81 { -1, misc_81 }
	MT_82 { -1, misc_82 }
	MT_83 { -1, misc_83 }
	MT_84 { -1, misc_84 }
	MT_85 { -1, misc_85 }
	MT_86 { -1, misc_86 }
	MT_87 { -1, misc_87 }
	MT_88 { -1, misc_88 }
	MT_89 { 3006, misc_89 }
	MT_90 { 186, misc_90 }
	MT_91 { 16, misc_91 }
	MT_92 { 71, misc_92 }
	MT_93 { -1, misc_93 }
	MT_94 { -1, misc_94 }
	MT_95 { -1, misc_95 }
	MT_96 { -1, misc_96 }
	MT_97 { -1, misc_97 }
	MT_98 { -1, misc_98 }
	MT_99 { -1, misc_99 }
	MT_100 { -1, misc_100 }
	MT_101 { -1, misc_101 }
	MT_102 { -1, misc_102 }
	MT_103 { -1, misc_103 }
	MT_104 { -1, misc_104 }
	MT_105 { -1, misc_105 }
	MT_106 { -1, misc_106 }
	MT_107 { -1, misc_107 }
	MT_108 { -1, misc_108 }
	MT_109 { -1, misc_109 }
	MT_110 { -1, misc_110 }
	MT_111 { -1, misc_111 }
	MT_112 { -1, misc_112 }
	MT_113 { -1, misc_113 }
	MT_PUFF { -1, misc_114 }
	MT_115 { -1, misc_115 }
	MT_116 { -1, misc_116 }
	MT_TFOG { -1, misc_teleport_fog }
	MT_IFOG { -1, misc_item_respawn_fog }
	MT_TELEPORTMAN { 14, misc_teleport_spot }
	MT_120 { 24, misc_120 }
	MT_121 { 27, misc_121 }
	MT_122 { 45, misc_122 }
	MT_123 { 182, misc_123 }
	MT_124 { 2011, misc_124 }
	MT_125 { 2012, misc_125 }
	MT_126 { 83, misc_126 }
	MT_127 { 59, misc_127 }
	MT_128 { 2019, misc_128 }
	MT_129 { 2018, misc_129 }
	MT_130 { 2014, misc_130 }
	MT_131 { 164, misc_131 }
	MT_132 { -1, misc_132 }
	MT_133 { -1, misc_133 }
	MT_134 { 185, misc_134 }
	MT_135 { 184, misc_135 }
	MT_136 { -1, misc_136 }
	MT_137 { 91, misc_137 }
	MT_138 { -1, misc_138 }
	MT_139 { -1, misc_139 }
	MT_140 { -1, misc_140 }
	MT_141 { 40, misc_141 }
	MT_142 { 13, misc_142 }
	MT_143 { 38, misc_143 }
	MT_144 { 61, misc_144 }
	MT_145 { -1, misc_145 }
	MT_146 { 86, misc_146 }
	MT_147 { 166, misc_147 }
	MT_148 { 39, misc_148 }
	MT_149 { 192, misc_149 }
	MT_150 { 193, misc_150 }
	MT_151 { 195, misc_151 }
	MT_152 { -1, misc_152 }
	MT_153 { -1, misc_153 }
	MT_154 { -1, misc_154 }
	MT_155 { -1, misc_155 }
	MT_156 { -1, misc_156 }
	MT_157 { -1, misc_157 }
	MT_158 { -1, misc_158 }
	MT_159 { 2024, misc_159 }
	MT_160 { 2025, misc_160 }
	MT_161 { 90, misc_161 }
	MT_162 { 52, misc_162 }
	MT_163 { 2026, misc_163 }
	MT_164 { 2027, misc_164 }
	MT_165 { 93, misc_165 }
	MT_166 { 138, misc_166 }
	MT_167 { 139, misc_167 }
	MT_168 { 140, misc_168 }
	MT_169 { -1, misc_169 }
	MT_170 { 205, misc_170 }
	MT_171 { -1, misc_171 }
	MT_172 { 206, misc_172 }
	MT_173 { 207, misc_173 }
	MT_174 { 152, misc_174 }
	MT_175 { 153, misc_175 }
	MT_176 { 84, misc_176 }
	MT_177 { 2007, misc_177 }
	MT_178 { 2048, misc_178 }
	MT_179 { 2010, misc_179 }
	MT_180 { 2046, misc_180 }
	MT_181 { 2047, misc_181 }
	MT_182 { 17, misc_182 }
	MT_183 { 115, misc_183 }
	MT_184 { 114, misc_184 }
	MT_185 { 183, misc_185 }
	MT_186 { 2002, misc_186 }
	MT_187 { 2006, misc_187 }
	MT_188 { 2005, misc_188 }
	MT_189 { -1, misc_189 }
	MT_190 { 2003, misc_190 }
	MT_191 { 2004, misc_191 }
	MT_192 { 2001, misc_192 }
	MT_193 { 154, misc_193 }
	MT_194 { 77, misc_194 }
	MT_195 { 78, misc_195 }
	MT_196 { 79, misc_196 }
	MT_197 { 80, misc_197 }
	MT_198 { 81, misc_198 }
	MT_199 { 92, misc_199 }
	MT_200 { 85, misc_200 }
	MT_201 { 82, misc_201 }
	MT_202 { 94, misc_202 }
	MT_203 { 208, misc_203 }
	MT_204 { 95, misc_204 }
	MT_205 { 96, misc_205 }
	MT_206 { 97, misc_206 }
	MT_207 { 2028, misc_207 }
	MT_208 { 48, misc_208 }
	MT_209 { 54, misc_209 }
	MT_210 { 55, misc_210 }
	MT_211 { 56, misc_211 }
	MT_212 { 57, misc_212 }
	MT_213 { 227, misc_213 }
	MT_214 { 98, misc_214 }
	MT_215 { 161, misc_215 }
	MT_216 { 160, misc_216 }
	MT_217 { 159, misc_217 }
	MT_218 { 162, misc_218 }
	MT_219 { 163, misc_219 }
	MT_220 { 34, misc_220 }
	MT_221 { 35, misc_221 }
	MT_222 { 103, misc_222 }
	MT_223 { 104, misc_223 }
	MT_224 { 53, misc_224 }
	MT_225 { 112, misc_225 }
	MT_226 { 113, misc_226 }
	MT_227 { 23, misc_227 }
	MT_228 { 22, misc_228 }
	MT_229 { 15, misc_229 }
	MT_230 { 18, misc_230 }
	MT_231 { 21, misc_231 }
	MT_232 { 20, misc_232 }
	MT_233 { 19, misc_233 }
	MT_234 { 212, misc_234 }
	MT_235 { 54, misc_235 }
	MT_236 { 70, misc_236 }
	MT_237 { 105, misc_237 }
	MT_238 { 106, misc_238 }
	MT_239 { 107, misc_239 }
	MT_240 { 108, misc_240 }
	MT_241 { 109, misc_241 }
	MT_242 { 28, misc_242 }
	MT_243 { 110, misc_243 }
	MT_244 { 44, misc_244 }
	MT_245 { 111, misc_245 }
	MT_246 { 43, misc_246 }
	MT_247 { 46, misc_247 }
	MT_248 { 99, misc_248 }
	MT_249 { 100, misc_249 }
	MT_250 { 101, misc_250 }
	MT_251 { 102, misc_251 }
	MT_252 { 215, misc_252 }
	MT_253 { 29, misc_253 }
	MT_254 { 30, misc_254 }
	MT_255 { 31, misc_255 }
	MT_256 { 32, misc_256 }
	MT_257 { 36, misc_257 }
	MT_258 { 37, misc_258 }
	MT_259 { 41, misc_259 }
	MT_260 { 42, misc_260 }
	MT_261 { 117, misc_261 }
	MT_262 { 47, misc_262 }
	MT_263 { 50, misc_263 }
	MT_264 { 51, misc_264 }
	MT_265 { 202, misc_265 }
	MT_266 { 203, misc_266 }
	MT_267 { 33, misc_267 }
	MT_268 { 60, misc_268 }
	MT_269 { 62, misc_269 }
	MT_270 { 63, misc_270 }
	MT_271 { 69, misc_271 }
	MT_272 { 165, misc_272 }
	MT_273 { 188, misc_273 }
	MT_274 { 189, misc_274 }
	MT_275 { 190, misc_275 }
	MT_276 { 191, misc_276 }
	MT_277 { 194, misc_277 }
	MT_278 { 196, misc_278 }
	MT_279 { 197, misc_279 }
	MT_280 { 68, misc_280 }
	MT_281 { 228, misc_281 }
	MT_282 { 216, misc_282 }
	MT_283 { 217, misc_283 }
	MT_284 { 218, misc_284 }
	MT_285 { 219, misc_285 }
	MT_286 { 220, misc_286 }
	MT_287 { 226, misc_287 }
	MT_288 { 221, misc_288 }
	MT_289 { 222, misc_289 }
	MT_290 { 223, misc_290 }
	MT_291 { 224, misc_291 }
	MT_292 { 225, misc_292 }
	MT_293 { 10, misc_293 }
	MT_294 { -1, misc_294 }
	MT_295 { -1, misc_295 }
	MT_296 { -1, misc_296 }
	MT_297 { -1, misc_297 }
	MT_298 { -1, misc_298 }
	MT_299 { -1, misc_299 }
	MT_300 { -1, misc_300 }
	MT_301 { -1, misc_301 }
	MT_302 { -1, misc_302 }
	MT_303 { -1, misc_303 }
	MT_304 { -1, misc_304 }
	MT_305 { -1, misc_305 }
	MT_306 { -1, misc_306 }
	MT_307 { -1, misc_307 }
	MT_308 { -1, misc_308 }
	MT_309 { -1, misc_309 }
	MT_310 { -1, misc_310 }
	MT_311 { -1, misc_311 }
	MT_312 { -1, misc_312 }
	MT_313 { -1, misc_313 }
	MT_314 { -1, misc_314 }
	MT_315 { -1, misc_315 }
}